.586p
.model flat, stdcall
option casemap :none

;******************************************************************************
;* INCLUDES                                                                   *
;******************************************************************************
include				\masm32\include\windows.inc
include				\masm32\include\user32.inc
include				\masm32\include\kernel32.inc
include				\masm32\include\shell32.inc
include				\masm32\include\advapi32.inc
include				\masm32\include\gdi32.inc
include				\masm32\include\comctl32.inc
include				\masm32\include\comdlg32.inc
include				\masm32\include\masm32.inc
include				\masm32\macros\macros.asm

includelib			\masm32\lib\user32.lib
includelib			\masm32\lib\kernel32.lib
includelib			\masm32\lib\shell32.lib
includelib			\masm32\lib\advapi32.lib
includelib			\masm32\lib\gdi32.lib
includelib			\masm32\lib\comctl32.lib
includelib			\masm32\lib\comdlg32.lib
includelib			\masm32\lib\masm32.lib

;******************************************************************************
;* PROTOTYPES                                                                 *
;******************************************************************************
DialogProc			PROTO :DWORD,:DWORD,:DWORD,:DWORD
GenPassword			PROTO :HWND
iRand				PROTO :DWORD

;******************************************************************************
;* DATA & CONSTANTS                                                           *
;******************************************************************************
.const
IDD_MAIN			equ 1
BTN_GEN				equ 101
IDC_PASSLEN			equ 102
IDC_CHARSET			equ 103
IDC_PASSWORD			equ 104

.data
charset				db "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ`~!@#$%^&*()_+-=[]{}\|;':,.<>/? ",200h dup(0)	
seed				dd 0

.data?
password			db 64 dup(?)

;******************************************************************************
;* CODE                                                                       *
;******************************************************************************
.code
main:
	invoke InitCommonControls
	invoke GetModuleHandle,0
        invoke DialogBoxParam,eax,1,0,addr DialogProc,0
        
        invoke ExitProcess,0

DialogProc proc uses ebx esi edi hwnd:dword,message:dword,wparam:dword,lparam:dword
	
	mov eax,message
	.if eax==WM_INITDIALOG
		
		invoke SetDlgItemInt,hwnd,IDC_PASSLEN,8,0
		invoke SetDlgItemText,hwnd,IDC_CHARSET,addr charset
		invoke GetTickCount
		mov seed,eax
		
	.elseif eax==WM_COMMAND
	
		mov eax,wparam
		.if ax==BTN_GEN
			
		invoke GenPassword,hwnd
		.endif
		
	.elseif eax==WM_CLOSE
	
		invoke EndDialog,hwnd,0
		
	.endif
	
	xor eax,eax
	ret 	                         
DialogProc endp


GenPassword proc hwnd:HWND

    LOCAL status:BOOL,plen:DWORD,clen:DWORD

    invoke GetDlgItemInt,hwnd,IDC_PASSLEN,addr status,0
    or eax,eax
    jz _ierror
    cmp eax,64
    ja _ierror
    cmp status,0
    jz _ierror
    mov plen,eax

    invoke GetDlgItemText,hwnd,IDC_CHARSET,addr charset, 200h
    cmp eax,2
    jb _ierror
    cmp eax,200h-1
    ja _ierror
    mov clen,eax

    mov ecx,plen
    mov edi,offset password
    _l1:
    mov esi,offset charset
    push clen
    call iRand
    add esi,eax
    lodsb
    stosb
    loop _l1
    xor al,al
    stosb

    invoke SetDlgItemText,hwnd,IDC_PASSWORD,addr password
    jmp _end

    _ierror:
    invoke SetDlgItemText,hwnd,IDC_PASSWORD,chr$("Incorrect Input.")

    _end:
	ret
GenPassword endp

iRand proc uses ebx edx _len:DWORD

	mov eax,_len
	xor ebx,ebx
	imul edx,[ebx+seed],08088405h
	inc edx
	mov [ebx+seed],edx
	mul edx 
	mov eax,edx
	ret
iRand endp

end main

Coded by N1ghtm4r3